//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
//
//  This code is distributed under the GNU Public License
//  which can be found at http://www.gnu.org/licenses/gpl.txt

/*----------------------------------------------------------------------------
* File Name           : Board.h
* Object              : Hardware specific Board Features Definition File.
*
* Creation            : NSn   20070227 after template by James P Lynch
*----------------------------------------------------------------------------
*/
#ifndef GenericBoard_h
#define GenericBoard_h


#define QROLLE_POWER_POT 1

#ifdef QROLLE_POWER_POT
#define POWERCONTROL 'P'
#endif



#define QROLLE_COMBO_SPI 1
//#define QROLLE_COMBO_TWI 1

#ifdef QROLLE_COMBO_SPI
#define COMBOGENERATION 'S'
#endif
#ifdef QROLLE_COMBO_TWI
#define COMBOGENERATION 'T'
#endif

//#define QROLLE_3000 1
//#define QROLLE_4000 1
//#define QROLLE_5000 1
//#define QROLLE_6000 1
#define QROLLE_7000X 1

#ifdef QROLLE_3000
#include "board_3000.h"
#define GENERATION  '3'
#endif
#ifdef QROLLE_4000
#include "board_4000.h"
#define GENERATION  '4'
#endif
#ifdef QROLLE_5000
#include "board_5000.h"
#define GENERATION  '5'
#endif
#ifdef QROLLE_6000
#include "board_6000.h"
#define GENERATION  '6'
#endif
#ifdef QROLLE_7000X
#include "board_7000X.h"
#define GENERATION  '7'
#include "AT91SAM7X256.h"
#include "lib_AT91SAM7X256.h"
#endif


////////////////////////////////////////////////////////////
// Common and added or changed variables etc.
// Check with epromhandler.h to be equal!
struct Parameters  //Max 64 bytes size!!!!
{
	volatile UINT AD9834Afrequency; 		// 4
	volatile UINT AD9834Bfrequency; 		// 8
	volatile UINT AD9834Splitfrequency; //12
	volatile BYTE IOportA; 							//13
	volatile BYTE IOportB; 							//14
	volatile BYTE ADCchannel; 					//15
	volatile WORD FQstepLen; 						//17
	volatile WORD Modes; 								//19
	volatile BYTE bPowerSetting; 				//21
	volatile WORD ModesB; 							//22
	volatile BYTE bTuningSetting;					//24
//	volatile XXXXX; 	Next entry			//25
};
#define MAXPOWERSETTING									31
#define MAXTUNINGSETTING								80
//#define SHOWPOWERDELAY 	  500
#define SHOWPOWERDELAY 	  50
#define SHOWVOLUMEDELAY   50
//#define SHOWVOLUMEDELAY   500

//20081209 ->
#define MIN_USED_DELAY   150
//20081209 <-

extern  volatile WORD           ShowPower;





#endif  // #define GenericBoard_h

