//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
//
//  This code is distributed under the GNU Public License
//  which can be found at http://www.gnu.org/licenses/gpl.txt

/*----------------------------------------------------------------------------
* File Name           : Board_7000X.h
* Object              : Hardware specific Board Features Definition File.
*
* Creation            : NSn   20070227 after template by James P Lynch
*----------------------------------------------------------------------------
*/
#ifndef Board_h
#define Board_h


#define __inline static inline

#define true	-1
#define false   0
#define NOREPEAT		(BYTE)(0)


// For this hardware, use these macros
#ifdef QROLLE_COMBO_SPI
#define Read_Combo_IO(port,data,count) SPI_Read_IO_port(COMBO_PORTSPI,port,data,count)
#define Write_Combo_IO(port,data,count) SPI_Write_IO_port(COMBO_PORTSPI,port,data,count)
#endif
#ifdef QROLLE_COMBO_TWI
#define Read_Combo_IO(port,data,count) TWI_Read_PCA9535_port(COMBO_PORTTWI,port,data,count)
#define Write_Combo_IO(port,data,count) TWI_Write_PCA9535_port(COMBO_PORTTWI,port,data,count)
#endif


enum porttypes { NO_PORT, A_PORT, B_PORT, A_CONFIG, B_CONFIG };

typedef unsigned long   ULONG;
typedef unsigned int   	UINT;
typedef unsigned char  	BYTE;
typedef unsigned short 	WORD;


//-----------------  
// PINIO Definition   
//-----------------  
#define PA0     (1<<0)    
#define PA1     (1<<1) 
#define PA2     (1<<2)    
#define PA3     (1<<3) 
#define PA4     (1<<4)    
#define PA5     (1<<5) 
#define PA6     (1<<6)    
#define PA7     (1<<7) 
#define PA8     (1<<8)    
#define PA9     (1<<9) 
#define PA10    (1<<10)    
#define PA11    (1<<11) 
#define PA12    (1<<12)    
#define PA13    (1<<13) 
#define PA14    (1<<14)    
#define PA15    (1<<15) 
#define PA16    (1<<16)    
#define PA17    (1<<17) 
#define PA18    (1<<18)    
#define PA19    (1<<19) 
#define PA20    (1<<20)    
#define PA21    (1<<21) 
#define PA22    (1<<22)    
#define PA23    (1<<23) 
#define PA24    (1<<24)    
#define PA25    (1<<25) 
#define PA26    (1<<26)    
#define PA27    (1<<27) 
#define PA28    (1<<28)    
#define PA29    (1<<29) 
#define PA30    (1<<30)    
#define PA31    (1<<31) 

#define PB0     (1<<0)    
#define PB1     (1<<1) 
#define PB2     (1<<2)    
#define PB3     (1<<3) 
#define PB4     (1<<4)    
#define PB5     (1<<5) 
#define PB6     (1<<6)    
#define PB7     (1<<7) 
#define PB8     (1<<8)    
#define PB9     (1<<9) 
#define PB10    (1<<10)    
#define PB11    (1<<11) 
#define PB12    (1<<12)    
#define PB13    (1<<13) 
#define PB14    (1<<14)    
#define PB15    (1<<15) 
#define PB16    (1<<16)    
#define PB17    (1<<17) 
#define PB18    (1<<18)    
#define PB19    (1<<19) 
#define PB20    (1<<20)    
#define PB21    (1<<21) 
#define PB22    (1<<22)    
#define PB23    (1<<23) 
#define PB24    (1<<24)    
#define PB25    (1<<25) 
#define PB26    (1<<26)    
#define PB27    (1<<27) 
#define PB28    (1<<28)    
#define PB29    (1<<29) 
#define PB30    (1<<30)    

#define aRXD0						PA0         
#define aTXD0						PA1     
#define	aDualLEDgreen		PA2        
#define	aDualLEDred		 	PA3     
#define	aENCODERA				PA4        
#define	aENCODERB				PA5     
#define	aENCODERSW			PA6        
#define	aHC139B					PA7     
#define	aUSBdetect			PA8        
#define	aUSBon					PA9     
#define	TWD							PA10        
#define	TWCK						PA11     
#define	NPCS0						PA12        
#define	aHC139A					PA13     
#define	aIOKE						PA14        
#define	NPCS3						PA15     
#define	MISO						PA16        
#define	MOSI						PA17     
#define	SPCK						PA18        
#define	aPA19						PA19     
#define	aSW7						PA20        
#define	aSW8						PA21     
#define	aPA22						PA22        
#define	aSW9						PA23     
#define	aSW10						PA24        
#define	aDReg						PA25     
#define	aDRd						PA26        
#define	aDRXD						PA27     
#define	aDTXD						PA28        
#define	aSummer					PA29     
#define	aPA30						PA30        

#define	bPB0							PB0       
#define	bPB1							PB1     
#define	bPB2							PB2       
#define	bPB3							PB3     
#define	bPB4							PB4       
#define	bPB5							PB5     
#define	bPB6							PB6       
#define	bPB7							PB7     
#define	bSW4							PB8       
#define	bSW3							PB9     
#define	bPB10							PB10       
#define	bPB11							PB11    
#define	bPB12							PB12       
#define	bEnaIOKE					PB13    
#define	bSW5							PB14       
#define	bSW6							PB15    
#define	bPB16							PB16       
#define	bPB17							PB17    
#define	bDEna							PB18       
#define	bDB0							PB19    
#define	bDB1							PB20       
#define	bDB2							PB21    
#define	bDB3							PB22       
#define	bDB4							PB23    
#define	bDB5							PB24       
#define	bDB6							PB25    
#define	bDB7							PB26       
#define bDISP_BackLite		PB27    
#define bPlusTx						PB28       
#define bInterrupt1  			PB29    
#define bInterrupt0  			PB30       
 
#define SetPinToOutputA(a)   AT91F_PIO_CfgOutput(AT91C_BASE_PIOA,a)
#define SetPinToOutputB(a)   AT91F_PIO_CfgOutput(AT91C_BASE_PIOB,a)
#define SetPinToInputA(a)   AT91F_PIO_CfgInput(AT91C_BASE_PIOA,a)
#define SetPinToInputB(a)   AT91F_PIO_CfgInput(AT91C_BASE_PIOB,a)
#define SetPinOnA(a)   AT91F_PIO_SetOutput(AT91C_BASE_PIOA,a)
#define ClearPinOnA(a)   AT91F_PIO_ClearOutput(AT91C_BASE_PIOA,a)
#define SetPinOnB(a)   AT91F_PIO_SetOutput(AT91C_BASE_PIOB,a)
#define ClearPinOnB(a)   AT91F_PIO_ClearOutput(AT91C_BASE_PIOA,a)

//-------------------------  
// Push Buttons Definition  ALL inputs! 
//-------------------------  
//                                  


#define aSW_MASK         (aSW7|aSW8|aSW9|aSW10)
#define bSW_MASK         (bSW3|bSW4|bSW5|bSW6)
#define MENUBUTTONS				(FIRST_BUTTON|SECOND_BUTTON|THIRD_BUTTON|FOURTH_BUTTON|FIFTH_BUTTON)

#define aENCODER_MASK        (aENCODERA|aENCODERB)		 
#define NoEncoderActive			(AT91F_PIO_IsInputSet(AT91C_BASE_PIOA,aENCODER_MASK)==aENCODER_MASK)
#define EncoderA_active			(!(AT91F_PIO_IsInputSet(AT91C_BASE_PIOA,aENCODERA)==aENCODERA))	  
#define EncoderB_active			(!(AT91F_PIO_IsInputSet(AT91C_BASE_PIOA,aENCODERB)==aENCODERB))	  
#define EncoderSwitch_active			(!(AT91F_PIO_IsInputSet(AT91C_BASE_PIOA,aENCODERSW)==aENCODERSW))	  

#define MAXENCODERCOUNT							0x7FFD

#define ENCODERTICS_4_MENU					 2
#define ENCODER_DEBOUNCE  					10
 
//-------------------------  
// Display Definitions  
//-------------------------  
// 
//Delay to give 37 us between data changes
#define DELAYBETWEENDATA   			54
#define DELAYBETWEENCOMMANDS   5400

#define DataBitsOffset  			 19

#define bCharacterBitMask (bDB0|bDB1|bDB2|bDB3|bDB4|bDB5|bDB6|bDB7)

#define SetWriteCommand					AT91F_PIO_ClearOutput(AT91C_BASE_PIOA,aDReg|aDRd)
#define SetWriteCharacters			AT91F_PIO_ClearOutput(AT91C_BASE_PIOA,aDReg|aDRd);\
AT91F_PIO_SetOutput(AT91C_BASE_PIOA,aDReg)

#define Write_Display_Data(a)  AT91F_PIO_ClearOutput(AT91C_BASE_PIOB,bCharacterBitMask);\
AT91F_PIO_SetOutput(AT91C_BASE_PIOB,(a << DataBitsOffset)) 

#define Toggle_Display_Latch  MakeShortDelay();AT91F_PIO_SetOutput(AT91C_BASE_PIOB,bDEna);\
MakeShortDelay();AT91F_PIO_ClearOutput(AT91C_BASE_PIOB,bDEna) 

#define SwitchONbacklite  AT91F_PIO_SetOutput(AT91C_BASE_PIOB,bDISP_BackLite)
#define SwitchOFFbacklite  AT91F_PIO_ClearOutput(AT91C_BASE_PIOB,bDISP_BackLite)

#define CheckBacklite (AT91F_PIO_IsOutputSet(AT91C_BASE_PIOB,bDISP_BackLite)==bDISP_BackLite)



#define bDBall (bDB0|bDB1|bDB2|bDB3|bDB4|bDB5|bDB6|bDB7)                                 	   
#define POS_50Hz							9
#define POS_500Hz							8
#define POS_10kHz							5


//------------------  
// USART Definition   
//------------------  
#define USART_BAUD_RATE 				115200
#define USART_INTERRUPT_LEVEL		1
#define MSG_SIZE 					1000

//-----------
//	Frequency parameters
//-----------
#define BIG_FQ_STEPS  			10000
#define MEDIUM_FQ_STEPS  			500
#define SMALL_FQ_STEPS  		 	 50
#define LSB_IFFREQUENCY  		 4998700
#define USB_IFFREQUENCY  		 5001200
#define CW_IFFREQUENCY  		 4999400
#define MAXDDSREFDECIMALS 			4
#define MAX_RIT_DIFFERENCE  10000



#define LowerTransverterLimit		14000000
#define UpperTransverterLimit		14999990
#define Lower160mLimit					1750000
#define Upper160mLimit					2050000
#define Lower80mLimit						3450000
#define Upper80mLimit						4050000
#define Lower40mLimit						6950000
#define Upper40mLimit						7350000
#define Lower30mLimit						10050000
#define Upper30mLimit						10200000
#define Lower20mLimit						13950000
#define Upper20mLimit						15000000
#define Lower17mLimit						18000000
#define Upper17mLimit						18200000



//-----------
//	Potentiometer
//-----------
#define MAXVOLUME				255
#define VOLUMESTEP			10
#define POTSPEEDREPEAT							50
#define POTSPEEDREPEATINTERVALL			35

//-----------
//	BUG
//-----------
#define SetPTTifNotExercise 		if(IsIOEX_reset){SetBitIOPTT;wBreakInDelay=wUsedDelay;};

#define CloseKey 						AT91F_PIO_SetOutput(AT91C_BASE_PIOA,aIOKE);SetPTTifNotExercise;
#define CheckForClosedKey 		AT91F_PIO_IsInputSet(AT91C_BASE_PIOA,aIOKE)
#define OpenKey 						AT91F_PIO_ClearOutput ( AT91C_BASE_PIOA, aIOKE );


#ifdef QROLLE_COMBO_TWI
#define BUG1				((AT91F_PIO_IsInputSet(AT91C_BASE_PIOB,bInterrupt1)==bInterrupt1))
#define BUG0				((AT91F_PIO_IsInputSet(AT91C_BASE_PIOB,bInterrupt0)==bInterrupt0))
#define BUG0orBUG1	(BUG0|BUG1)
#endif
 
#define SHOWBUGSPEED								200

#define MINBUGSPEED									40
#define MAXBUGSPEED									250

#define BUGSPEEDREPEAT							50
#define BUGSPEEDREPEATINTERVALL			35

#define BUGSPEEDPOSITIONINDISPLAY		11

#define LongBit 				1
#define ShortBit 				2
#define LongIsActive 		((AkeyISpressed&LongBit)==LongBit)
#define ShortIsActive 	((AkeyISpressed&ShortBit)==ShortBit)
#define LongIsOff 			((AkeyISpressed&~LongBit)==0)
#define ShortIsOff 			((AkeyISpressed&~ShortBit)==0)
#define SetLongActive 	(AkeyISpressed|=LongBit)
#define SetShortActive 	(AkeyISpressed|=ShortBit)
#define SetLongOff 			(AkeyISpressed&=~LongBit)
#define SetShortOff 		(AkeyISpressed&=~ShortBit)
#define AkeyIsActive 		((AkeyISpressed&(LongBit|ShortBit))>0)
#define NoKeyIsActive 	((AkeyISpressed&(LongBit|ShortBit))==0)

//-----------
//	PITCH
//-----------
#define PITCHOFFSET									700

//-----------
//	ADC
//-----------
#define ADCREFERENCE								5000
#define VOLTREFERENCE								3600
#define AT_VOLT											13500

#define POWERREFERENCE							2000
#define VALUE4S9_30 ((POWERREFERENCE*4096)/ADCREFERENCE)

#define   AdcChannel9volt		6
#define   AdcChannel5volt		4
#define   AdcChannel3_3volt	5

#define   POS_9VOLT			14
#define   POS_5VOLT			23
#define   POS_3_3VOLT		35

//#define Calc_9volt    1010
#define Calc_9volt    1056
// ((6200*2500)/(15*1023))
// = 1010.1010
//#define Calc_5volt    577
//#define Calc_5volt    611
#define Calc_5volt    603
// ((2500*2500)/(10*1023))
// = 610.95
//#define Calc_3_3volt  375
//#define Calc_3_3volt  407
#define Calc_3_3volt  395
// ((2500*2500)/(15*1023))
// = 407,30


//-----------
//	TRANSVERTER
//-----------
#define TRANSVERTERFQ								14000000

//-----------
//	EEPROM
//-----------


//--------------  
// Master Clock   
//--------------  

#define EXT_OC          18432000   // External oscillator MAINCK
#define AT91B_MCK       ((18432000*73/14)/2)   // Output PLL Clock (48 MHz)
//#define MCK           48054841   // MCK (PLLRC div by 2)
#define MCKKHz          (AT91B_MCK/1000) //

#define SPI_clock_size_Combo								31
#define SPI_clock_size_EEPROM								31



#define DEBOUNCE1MS										4
#define FIVESECONDSIN5MSINCREMENTS		1000
//In main loop...
#define NUMBERof5msDELAYS							4
#define TEN_SECONDS_DELAY							2000
#define TIME_2_ACTIVATE_SUBFUNCTON		100

//#define FIRSTREPEAT      	80 
//#define NEXTREPEAT      	130 
#define FIRSTREPEAT      	30 
#define NEXTREPEAT      	45 

//Below values must follow each other!!!!! See manual!

#define CONTROLCHANGED								0xFF

// Summer
#define EnableSummer	AT91F_PIO_SetOutput(AT91C_BASE_PIOA,aSummer)
#define DisableSummer	AT91F_PIO_ClearOutput(AT91C_BASE_PIOA,aSummer)


// Buttons

#define 	MAX_LENGTH_OF_BUTTON_TONE		1000
#define 	MIN_LENGTH_OF_BUTTON_TONE		50
// LENGTH_OF_BUTTON_PERIOD 10 => 1 kHz
#define 	LENGTH_OF_BUTTON_PERIOD	15
//#define 	LENGTH_OF_BUTTON_PERIOD	40

#define 	BUTTONFlt 						0x01
#define 	BUTTONPre 						0x02
#define 	BUTTONMd 							0x04
#define 	BUTTONMENU 						0x04
#define 	BUTTONRIT 						0x08
#define 	BUTTONABSplit					0x10
#define 	BUTTONBdw							0x20
#define 	BUTTONStep						0x40
#define 	BUTTONBup							0x80

#define FIRST_BUTTON   	((AT91F_PIO_GetInput(AT91C_BASE_PIOA)&aSW10)==aSW10)
#define SECOND_BUTTON   ((AT91F_PIO_GetInput(AT91C_BASE_PIOA)&aSW9)==aSW9)
#define THIRD_BUTTON    ((AT91F_PIO_GetInput(AT91C_BASE_PIOA)&aSW8)==aSW8)
#define FOURTH_BUTTON   ((AT91F_PIO_GetInput(AT91C_BASE_PIOA)&aSW7)==aSW7)
#define FIFTH_BUTTON   	((AT91F_PIO_GetInput(AT91C_BASE_PIOB)&bSW6)==bSW6)
#define SIXTH_BUTTON   	((AT91F_PIO_GetInput(AT91C_BASE_PIOB)&bSW5)==bSW5)
#define SEVENTH_BUTTON 	((AT91F_PIO_GetInput(AT91C_BASE_PIOB)&bSW4)==bSW4) 
#define EIGHTH_BUTTON   ((AT91F_PIO_GetInput(AT91C_BASE_PIOB)&bSW3)==bSW3)

// pointer to PIO data structure
//extern	volatile AT91PS_PIO	pPIOA;
//extern	volatile AT91PS_SPI	pSpi;

#define MENUBUTTON				0x01
#define SOUND_UP					0x02
#define LAMP_TOGGLE				0x04
#define SOUND_DOWN				0x08
#define STEPFORWARD				MENUBUTTON+SOUND_UP
#define STEPBACK					MENUBUTTON+SOUND_DOWN

// Number of 5 ms periods for...
#define KNOBDEBOUNCE			8
#define DEBOUNCE					4
//#define DEBOUNCE					2


// SPI constants
#define EnableDDS					AT91F_PIO_ClearOutput(AT91C_BASE_PIOA,aHC139A);AT91F_PIO_SetOutput(AT91C_BASE_PIOA,aHC139B);
#define EnablePot					AT91F_PIO_ClearOutput(AT91C_BASE_PIOA,aHC139B);AT91F_PIO_SetOutput(AT91C_BASE_PIOA,aHC139A);
#define EnableADC					AT91F_PIO_ClearOutput(AT91C_BASE_PIOA,aHC139A|aHC139B);
#define EnableComboIO			AT91F_PIO_SetOutput(AT91C_BASE_PIOA,aHC139A|aHC139B);

// Address def's in IO via SPI


#define COMBO_PORTSPI					0x2
#define COMBO_PORTTWI					0x8
			
#define COMBO_PORTSPI_Write		0x40			
#define COMBO_PORTSPI_Read		0x41	
		

//We address as for BANK=0 => sequential addresses
#define MCP23S17_CMD_OUTPUT_CONFIG_A			0x00
#define MCP23S17_CMD_OUTPUT_CONFIG_B			0x01
#define MCP23S17_CMD_POL_INVERSION_A			0x02
#define MCP23S17_CMD_POL_INVERSION_B			0x03
#define MCP23S17_CMD_OUTPUT_IOCON					0x05

#define MCP23S17_CMD_CONFIGREG						0x0A

#define MCP23S17_CMD_INPUT_A							0x12
#define MCP23S17_CMD_INPUT_B							0x13
#define MCP23S17_CMD_OUTPUT_A							0x14
#define MCP23S17_CMD_OUTPUT_B							0x15



#define ADD_OUTPUT			0x01

#ifdef QROLLE_COMBO_SPI

/// Some are outputs
#define ComboIO_VALUE_OUTPUT_CONFIG_A		0x00 
#define ComboIO_OUTPUT_MASK_A						0xFF 
#define ComboIO_VALUE_OUTPUT_CONFIG_B		0xC0 
#define ComboIO_OUTPUT_MASK_B						0x3F 

// In first output byte:
#define IOHF						0x01
#define SetIOHF					(param.IOportA |=IOHF);Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define ResetIOHF				(param.IOportA &=~(IOHF));Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define IsIOHF_reset 		((param.IOportA &IOHF)==0)
#define IsIOHF_set 			((param.IOportA &IOHF)==IOHF)
#define SetBitIOHF			(param.IOportA |=IOHF);
#define ResetBitIOHF		(param.IOportA &=~(IOHF));

#define IOKO						0x02
#define SetIOKO					(param.IOportA |=IOKO);Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define ResetIOKO				(param.IOportA &=~(IOKO));Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define IsIOKO_reset 		((param.IOportA &IOKO)==0)
#define IsIOKO_set 			((param.IOportA &IOKO)==IOKO)
#define SetBitIOKO			(param.IOportA |=IOKO);
#define ResetBitIOKO		(param.IOportA &=~(IOKO));


#define IOBW						0x04
#define SetIOBW					(param.IOportA |=IOBW);Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define ResetIOBW				(param.IOportA &=~(IOBW));Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define SetBitIOBW			(param.IOportA |=IOBW);
#define ResetBitIOBW		(param.IOportA &=~(IOBW));

#define IO17						0x08
#define SetIO17					(param.IOportA |=IO17);Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define ResetIO17				(param.IOportA &=~(IO17));Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define SetBitIO17			(param.IOportA |=IO17);
#define ResetBitIO17		(param.IOportA &=~(IO17));

#define IO20						0x10
#define SetIO20					(param.IOportA |=IO20);Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define ResetIO20				(param.IOportA &=~(IO20));Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define SetBitIO20			(param.IOportA |=IO20);
#define ResetBitIO20		(param.IOportA &=~(IO20));

#define IO30						0x20
#define SetIO30					(param.IOportA |=IO30);Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define ResetIO30				(param.IOportA &=~(IO30));Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define SetBitIO30			(param.IOportA |=IO30);
#define ResetBitIO30		(param.IOportA &=~(IO30));

#define IO40						0x40
#define SetIO40					(param.IOportA |=IO40);Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define ResetIO40				(param.IOportA &=~(IO40));Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define SetBitIO40			(param.IOportA |=IO40);
#define ResetBitIO40		(param.IOportA &=~(IO40));

#define IO80					0x80
#define SetIO80				(param.IOportA |=IO80);Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define ResetIO80			(param.IOportA &=~(IO80));Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );
#define SetBitIO80		(param.IOportA |=IO80);
#define ResetBitIO80	(param.IOportA &=~(IO80));

// In second output byte:

#define IOPTT						0x01
#define SetIOPTT				(param.IOportB |=IOPTT);Write_Combo_IO ( B_PORT, (BYTE*)&param.IOportB, 1 );
#define ResetIOPTT			(param.IOportB &=~(IOPTT));Write_Combo_IO ( B_PORT, (BYTE*)&param.IOportB, 1 );
#define IsIOPTT_reset 	((param.IOportB &IOPTT)==0)
#define IsIOPTT_set 		((param.IOportB &IOPTT)==IOPTT)
#define SetBitIOPTT			(param.IOportB |=IOPTT);
#define ResetBitIOPTT		(param.IOportB &=~(IOPTT));

#define IOSB						0x02
#define SetIOSB					(param.IOportB |=IOSB);Write_Combo_IO ( B_PORT, (BYTE*)&param.IOportB, 1 );
#define ResetIOSB				(param.IOportB &=~(IOSB));Write_Combo_IO ( B_PORT, (BYTE*)&param.IOportB, 1 );
#define SetBitIOSB			(param.IOportB |=IOSB);
#define ResetBitIOSB		(param.IOportB &=~(IOSB));

#define IOMO						0x04
#define SetIOMO					(param.IOportB |=IOMO);Write_Combo_IO ( B_PORT, (BYTE*)&param.IOportB, 1 );
#define ResetIOMO				(param.IOportB &=~(IOMO));Write_Combo_IO ( B_PORT, (BYTE*)&param.IOportB, 1 );
#define SetBitIOMO			(param.IOportB |=IOMO);
#define ResetBitIOMO		(param.IOportB &=~(IOMO));

#define IOTV						0x08
#define SetIOTV					(param.IOportB |=IOTV);Write_Combo_IO ( B_PORT, (BYTE*)&param.IOportB, 1 );
#define ResetIOTV				(param.IOportB &=~(IOTV));Write_Combo_IO ( B_PORT, (BYTE*)&param.IOportB, 1 );
#define SetBitIOTV			(param.IOportB |=IOTV);
#define ResetBitIOTV		(param.IOportB &=~(IOTV));


#define IOEX            0x10
#define SetIOEX         (param.IOportB |=IOEX);Write_Combo_IO ( B_PORT, (BYTE*)&param.IOportB, 1 );
#define ResetIOEX       (param.IOportB &=~(IOEX));Write_Combo_IO ( B_PORT, (BYTE*)&param.IOportB, 1 );
#define IsIOEX_reset    ((param.IOportB &IOEX)==0)
#define IsIOEX_set      ((param.IOportB &IOEX)==IOEX)
#define SetBitIOEX      (param.IOportB |=IOEX);
#define ResetBitIOEX    (param.IOportB &=~(IOEX));


#define IO160						0x20
#define SetIO160				(param.IOportB |=IO160);Write_Combo_IO ( B_PORT, (BYTE*)&param.IOportB, 1 );
#define ResetIO160			(param.IOportB &=~(IO160));Write_Combo_IO ( B_PORT, (BYTE*)&param.IOportB, 1 );
#define SetBitIO160			(param.IOportB |=IO160);
#define ResetBitIO160		(param.IOportB &=~(IO160));

//Bits 6 and 7 are input for BUG now!
#define Bug0BitInIO  0x40
#define Bug1BitInIO  0x80


#define ResetFQbands 		param.IOportA &=~((IO17)|(IO20)|(IO30)|(IO40)|(IO80));param.IOportB &=~((IO160)|(IOTV));\
Write_Combo_IO ( A_PORT, (BYTE*)&param.IOportA, 1 );\
Write_Combo_IO ( B_PORT, (BYTE*)&param.IOportB, 1 );

#define ResetFQbandBits param.IOportA &=~((IO17)|(IO20)|(IO30)|(IO40)|(IO80));param.IOportB &=~((IO160)|(IOTV));
// Bits in input
#endif  // QROLLE_COMBO_SPI

#ifdef QROLLE_COMBO_TWI

/// Some are outputs
#define ComboIO_VALUE_OUTPUT_CONFIG_A		0x00 
#define ComboIO_OUTPUT_MASK_A						0xFF 
#define ComboIO_VALUE_OUTPUT_CONFIG_B		0x00 
#define ComboIO_OUTPUT_MASK_B						0xFF 

// In first output byte:
#define IOHF						0x01
#define SetIOHF					(param.IOportA|=IOHF);Write_Combo_IO(A_PORT,(BYTE*)&param.IOportA,1);
#define ResetIOHF				(param.IOportA&=~(IOHF));Write_Combo_IO(A_PORT,(BYTE*)&param.IOportA,1);
#define IsIOHF_reset 		((param.IOportA&IOHF)==0)
#define IsIOHF_set 			((param.IOportA&IOHF)==IOHF)
#define SetBitIOHF			(param.IOportA|=IOHF);
#define ResetBitIOHF		(param.IOportA&=~(IOHF));

#define IOKO						0x02
#define SetIOKO					(param.IOportA|=IOKO);Write_Combo_IO(A_PORT,(BYTE*)&param.IOportA,1);
#define ResetIOKO				(param.IOportA&=~(IOKO));Write_Combo_IO(A_PORT,(BYTE*)&param.IOportA,1);
#define IsIOKO_reset 		((param.IOportA&IOKO)==0)
#define IsIOKO_set 			((param.IOportA&IOKO)==IOKO)
#define SetBitIOKO			(param.IOportA|=IOKO);
#define ResetBitIOKO		(param.IOportA&=~(IOKO));


#define IOBW						0x08
#define SetIOBW					(param.IOportA|=IOBW);Write_Combo_IO(A_PORT,(BYTE*)&param.IOportA,1);
#define ResetIOBW				(param.IOportA&=~(IOBW));Write_Combo_IO(A_PORT,(BYTE*)&param.IOportA,1);
#define SetBitIOBW			(param.IOportA|=IOBW);
#define ResetBitIOBW		(param.IOportA&=~(IOBW));

#define IO17						0x10
#define SetIO17					(param.IOportA|=IO17);Write_Combo_IO(A_PORT,(BYTE*)&param.IOportA,1);
#define ResetIO17				(param.IOportA&=~(IO17));Write_Combo_IO(A_PORT,(BYTE*)&param.IOportA,1);
#define SetBitIO17			(param.IOportA|=IO17);
#define ResetBitIO17		(param.IOportA&=~(IO17));

#define IO20						0x20
#define SetIO20					(param.IOportA|=IO20);Write_Combo_IO(A_PORT,(BYTE*)&param.IOportA,1);
#define ResetIO20				(param.IOportA&=~(IO20));Write_Combo_IO(A_PORT,(BYTE*)&param.IOportA,1);
#define SetBitIO20			(param.IOportA|=IO20);
#define ResetBitIO20		(param.IOportA&=~(IO20));

#define IO30						0x40
#define SetIO30					(param.IOportA|=IO30);Write_Combo_IO(A_PORT,(BYTE*)&param.IOportA,1);
#define ResetIO30				(param.IOportA&=~(IO30));Write_Combo_IO(A_PORT,(BYTE*)&param.IOportA,1);
#define SetBitIO30			(param.IOportA|=IO30);
#define ResetBitIO30		(param.IOportA&=~(IO30));

#define IO40						0x80
#define SetIO40					(param.IOportA|=IO40);Write_Combo_IO(A_PORT,(BYTE*)&param.IOportA,1);
#define ResetIO40				(param.IOportA&=~(IO40));Write_Combo_IO(A_PORT,(BYTE*)&param.IOportA,1);
#define SetBitIO40			(param.IOportA|=IO40);
#define ResetBitIO40		(param.IOportA&=~(IO40));

#define IOportA_STARTVALUE  (IOBW)

// In second output byte:
//Bit 0 is input for BUG now!
#define Bug0BitInPCA9535  0x01

#define IOPTT						0x02
#define SetIOPTT				(param.IOportB|=IOPTT);Write_Combo_IO(B_PORT,(BYTE*)&param.IOportB,1);
#define ResetIOPTT			(param.IOportB&=~(IOPTT));Write_Combo_IO(B_PORT,(BYTE*)&param.IOportB,1);
#define IsIOPTT_reset 	((param.IOportB&IOPTT)==0)
#define IsIOPTT_set 		((param.IOportB&IOPTT)==IOPTT)
#define SetBitIOPTT			(param.IOportB|=IOPTT);
#define ResetBitIOPTT		(param.IOportB&=~(IOPTT));

#define IOSB						0x04
#define SetIOSB					(param.IOportB|=IOSB);Write_Combo_IO(B_PORT,(BYTE*)&param.IOportB,1);
#define ResetIOSB				(param.IOportB&=~(IOSB));Write_Combo_IO(B_PORT,(BYTE*)&param.IOportB,1);
#define SetBitIOSB			(param.IOportB|=IOSB);
#define ResetBitIOSB		(param.IOportB&=~(IOSB));

#define IOMO						0x08
#define SetIOMO					(param.IOportB|=IOMO);Write_Combo_IO(B_PORT,(BYTE*)&param.IOportB,1);
#define ResetIOMO				(param.IOportB&=~(IOMO));Write_Combo_IO(B_PORT,(BYTE*)&param.IOportB,1);
#define SetBitIOMO			(param.IOportB|=IOMO);
#define ResetBitIOMO		(param.IOportB&=~(IOMO));

#define IOTV						0x10
#define SetIOTV					(param.IOportB|=IOTV);Write_Combo_IO(B_PORT,(BYTE*)&param.IOportB,1);
#define ResetIOTV				(param.IOportB&=~(IOTV));Write_Combo_IO(B_PORT,(BYTE*)&param.IOportB,1);
#define SetBitIOTV			(param.IOportB|=IOTV);
#define ResetBitIOTV		(param.IOportB&=~(IOTV));


//Bit 5 is input for BUG now!
//#define Bug1BitInPCA9535  0x20
#define IOEX            0x20
#define SetIOEX         (param.IOportB|=IOEX);Write_Combo_IO(B_PORT,(BYTE*)&param.IOportB,1);
#define ResetIOEX       (param.IOportB&=~(IOEX));Write_Combo_IO(B_PORT,(BYTE*)&param.IOportB,1);
#define IsIOEX_reset    ((param.IOportB&IOEX)==0)
#define IsIOEX_set      ((param.IOportB&IOEX)==IOEX)
#define SetBitIOEX      (param.IOportB|=IOEX);
#define ResetBitIOEX    (param.IOportB&=~(IOEX));


#define IO160						0x40
#define SetIO160				(param.IOportB|=IO160);Write_Combo_IO(B_PORT,(BYTE*)&param.IOportB,1);
#define ResetIO160			(param.IOportB&=~(IO160));Write_Combo_IO(B_PORT,(BYTE*)&param.IOportB,1);
#define SetBitIO160			(param.IOportB|=IO160);
#define ResetBitIO160		(param.IOportB&=~(IO160));

#define IO80					0x80
#define SetIO80				(param.IOportB|=IO80);Write_Combo_IO(B_PORT,(BYTE*)&param.IOportB,1);
#define ResetIO80			(param.IOportB&=~(IO80));Write_Combo_IO(B_PORT,(BYTE*)&param.IOportB,1);
#define SetBitIO80		(param.IOportB|=IO80);
#define ResetBitIO80	(param.IOportB&=~(IO80));
#define IOportB_STARTVALUE  (IO80)

#define ResetFQbands 		param.IOportA&=~((IO17)|(IO20)|(IO30)|(IO40));param.IOportB&=~((IO160)|(IO80)|(IOTV));\
AT91_TWI_Write_2_both_ports	( param.IOportA, param.IOportB );

#define ResetFQbandBits param.IOportA&=~((IO17)|(IO20)|(IO30)|(IO40));param.IOportB&=~((IO160)|(IO80)|(IOTV));
// Bits in input
#endif //QROLLE_COMBO_TWI

#define PlusTX			((AT91F_PIO_IsInputSet(AT91C_BASE_PIOB,bPlusTx)==bPlusTx))

#define SHORTDELAY  200
#define LONGDELAY  1000


// 10 = 0,7W   15 = 1.6 W
// 3 = approx 1W
// #define POWER4TUNING  15
#define POWER4TUNING  3

extern volatile UINT			timer0count;
extern volatile UINT			timer1count;
extern volatile UINT			timer3count;
extern struct Parameters  param;
extern volatile BYTE			UsedFQ;
extern volatile WORD			ShowVolume;
extern volatile BYTE			Band;
extern volatile BYTE			Pot1Volume;
extern volatile WORD			wUsedDelay;
extern volatile BYTE			ModeChanged;
extern volatile WORD			wBugSpeed;
extern volatile BYTE			bBugSpeedChange;
//extern volatile BYTE			DotCount;
//extern volatile BYTE			DahCount;
//extern volatile BYTE			SpaceCount;
extern	volatile WORD 			DVMReference;
extern	volatile BYTE			ButtonActionBdw;
extern	volatile BYTE			ButtonActionstep;
extern	volatile BYTE			ButtonActionBup;
extern	volatile BYTE			DisplayMode;
extern const char                       cCompileDate [];
extern const char                       cVersion [];
extern const char               cDVMRefStart[];
extern const char               cDVMRef[];

extern  volatile UINT           TimeInMainLoop;
extern  volatile UINT           timeSinceLastSave;
extern  volatile BYTE           timing0;
extern  volatile UINT           EncoderDirection;
extern  volatile BYTE           mainmode;
extern  volatile WORD           subfunctiontiming;
extern  volatile UINT           AD9834RefFrequency; 
extern  volatile UINT           AD9834RIT_Afrequency; 
extern  volatile UINT           AD9834RIT_Bfrequency; 
extern  volatile UINT						EncoderCW_count;
extern  volatile UINT						EncoderCCW_count;

extern  volatile WORD           wCheck4eeprom;
extern volatile BYTE            LastValidInport;
extern volatile WORD            ShowVoltage;
extern volatile BYTE            ShowBugSpeed;
extern volatile BYTE            bIambicMode;
//extern volatile WORD            wBugCountDown;
extern volatile WORD            wBugCountValue;
extern	volatile BYTE						ButtonActionFlt;
extern	volatile BYTE						ButtonActionPre;
extern	volatile BYTE						ButtonActionMd;
extern	volatile BYTE						ButtonActionCom;
extern	volatile BYTE						ButtonActionABSplit;
extern	volatile BYTE						ButtonActionBdw;
extern	volatile BYTE						ButtonActionstep;
extern	volatile BYTE						ButtonActionBup;
extern  volatile WORD           wDisplayBackLiteTime;
extern  volatile BYTE           NumberBuffer [ ];
extern  volatile BYTE    				AutoInformationFlag;
extern  volatile BYTE						BugConnection;
extern  volatile WORD						wBreakInDelay;
extern  volatile BYTE 					bBaudrate;
extern  volatile BYTE 					menuPosRow;
extern  volatile BYTE 					menuPosCol;
extern  volatile char 					OutBuffer [ 16 ];
extern  volatile char 					OutBufferUSB [ 16 ];
extern  volatile WORD           LowFqTone;
extern  volatile WORD           HighFqTone;
extern  volatile WORD           SummerCounter;
extern  volatile WORD						wButtonSoundLen;
extern  volatile BYTE 					bSPLITFQmode;
extern  volatile BYTE 					bSet2transmit;
extern	volatile BYTE 					BuggLongActive;
extern	volatile BYTE 					BuggShortActive;
extern  volatile BYTE        		AkeyISpressed;
extern	volatile WORD				*		AorBmode;

extern  struct _AT91S_CDC 	    	pCDC;

enum moder { RXmode, TXmode, MENUMODE };
enum displaymode { DisplayOff, DisplayOn, DisplayAuto };
enum mode2 { LSB, USB, CW };
enum FILTER { WIDE, NARROW };
enum direction { NODIR, CLOCKWISE, ANTICLOCKWISE };
enum BANDS { B160, B80, B40, B30, B20, B17, Transverter };
enum IambicMode { NoIambicMode, IambicModeA, IambicModeB, AccukeyMode, StraightKey };
enum eBugStates { Idle, KeyDown, KeyDownDelay, SpaceDelay, InterCharDelay };
enum PaddleCheck { NoPaddle, SHORTPADDLE, LONGPADDLE };
#define ShortDelay 	  100
#define LongDelay 	  500
//From HamRadioDeluxe:
#define MAXDELAY 	  3000

//#define SHOWVOLUMEDELAY 	  500

//enum FQused { AFQ, BFQ, SPLITFQ };
#define MAXFILTER NARROW

// Modes list
#define NonRITmode									0x0
#define RITmode											0x01

#define AFQmode											0x00
#define BFQmode											0x02
//#define SPLITFQmode									0x04
//#define BFQmodeOR_SPLITFQmode				0x06

#define WIDEmode										0x00
#define NARROWmode									0x08

#define CWmode											0x00
//#define Digimode										0x10
#define USBmode											0x20
#define LSBmode											0x30

#define Compress										0x40
#define PreAmp											0x80

void InitController ( void );
void	SetTimer4Bug ( WORD wBugSpeed );
extern int main ( void );
extern const char cInvalidRS232Cmd[];
extern const char cInvalidUSBCmd[];
extern void bug_handler ( void );
extern void SetBaudRate ( void );

#endif // Board_h   
