//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
//
//  This code is distributed under the GNU Public License
//  which can be found at http://www.gnu.org/licenses/gpl.txt

/*----------------------------------------------------------------------------
* File Name           : display.c
// Object              : QROlleSAM7S Board Features Definition File.
//
// Creation            : NSn   20080111
*----------------------------------------------------------------------------
*/

#include "Board.h"
#include "SPI_ctrl.h"
#include "a2dmodule.h"

//+++++++++++++++++++++++++++++++++++++++++++++++++

WORD	GetADCvalue ( BYTE AdcChannel, AT91PS_SPI pSPI )
{
	WORD						RXvalue;
	UINT					 	Data_To_Send;
  UINT						Data_Recieved = 0;
	
	EnableADC;

	WaitUntilReady4TX ( AT91C_BASE_SPI0 );//20090414
// Cfg SPI MR
		// SPI is in master mode + CS not variable + CS directly connected + 
		// no Fault mode + min DLYBCS
		AT91C_BASE_SPI0 -> SPI_MR = (AT91C_SPI_MSTR | AT91C_SPI_MODFDIS | ADD_SPI_CS0 );
		// For device 0 ( MCP3202 ) set speed to MCKL/16 and 9 bits, 
		// CS active after transfer, mode 0, 1 clk delay b4 CS up
	AT91F_Set_SPI_CSR ( AT91C_BASE_SPI0, 
//20090315										( 8 << 8 ) | 
										( SPI_clock_size_Combo << 8 ) | 
										AT91C_SPI_BITS_9 | 
										AT91C_SPI_NCPHA | 
										AT91C_SPI_CSAAT | 
										( 1 << 24 ), 
										CSR0 );

	Data_To_Send = StartBit | SingelBit | AdcChannel | ADD_SPI_CS0;
	AT91F_SPI_Send_Data ( AT91C_BASE_SPI0, Data_To_Send );
	Data_Recieved = AT91F_SPI_Read_Data (AT91C_BASE_SPI0);
	while (spi_Tdre_Flag == 0);
	RXvalue = ( Data_Recieved & 0x0F ) << 8;
	
	Data_To_Send = 0 | ADD_SPI_CS0 | LASTXFER;
	AT91F_SPI_Send_Data ( AT91C_BASE_SPI0, Data_To_Send );
	Data_Recieved = AT91F_SPI_Read_Data (AT91C_BASE_SPI0);
	while (spi_Tdre_Flag == 0);
	RXvalue += (( Data_Recieved & 0x1FE ) >> 1 );


	return RXvalue;	
};	

//+++++++++++++++++++++++++++++++++++++++++++++++++

void	SetupAT91SAM_ADC ( void )
{
    UINT result, running_mode;
		
/* First step: Enable ADC's Clock at PMC level.*/
  AT91F_PMC_EnablePeriphClock ( AT91C_BASE_PMC, 1 << AT91C_ID_ADC ) ;
	/* Second step: Set up by using ADC Mode register */
	running_mode = ((SHTIM << 24) | (STARTUP << 16) | (PRESCAL << 8) | (SLEEP << 5) | (LOWRES <<4) | (TRGSEL << 1) | (TRGEN ));
	AT91F_ADC_CfgModeReg (AT91C_BASE_ADC, running_mode) ;
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

WORD	GetAT91SAM_ADCvalue ( BYTE AdcChannel )
{
	WORD  result;
	/* Select the active channel */
	AT91F_ADC_EnableChannel ( AT91C_BASE_ADC, ( 1 << AdcChannel ));
	
//	timing0 = 10;
//	while ( timing0 > 0 );
	
	/* Start the conversion */
	AT91F_ADC_StartConversion ( AT91C_BASE_ADC );

	/* Waiting Stop Of conversion by pulling */
	while (!((AT91F_ADC_GetStatus ( AT91C_BASE_ADC )) & ( 1 << AdcChannel )));

	/* Read the result */
	result = AT91F_ADC_GetLastConvertedData ( AT91C_BASE_ADC );
	
	return result;
};

//+++++++++++++++++++++++++++++++++++++++++++++++++
