//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
//
//  This code is distributed under the GNU Public License
//  which can be found at http://www.gnu.org/licenses/gpl.txt

/*----------------------------------------------------------------------------
* File Name           : display.h
// Object              : QROlleSAM7S Board Features Definition File.
//
// Creation            : NSn   20080111
*----------------------------------------------------------------------------
*/


#ifndef Display_h
#define Display_h
// Display related defines

#define NORMALEXETIME 							2
#define EXTENDEDEXETIME 						33

//Size in char's of display
#define CHAR_ON_DISPLAY				40

#define DISPLAY_UPDATE_5MS_PERIODS	20

#define DISPLAYBUSYFLAG			0x80

#define SETDDRAMADDRESS			0x80

// set display for two line mode, display on
#define FUNCTIONSET					0x3C
// set display for display on, cursor on, blink off
#define DISPLAYSET					0x0E

#define DISPLAYCLEAR				0x01
//Set display entry mode to increment, entire shift off
#define DISPLAYINCRMODE			0x06


// Address for setting homemade pattern
#define CGRAMSET					0x40
//... and back
#define DGRAMSET					0x80

//Set cursor position
#define CURSORSET					0x80


//Line and total length of display
#define CHAR_ON_ONE_LINE			20
#define CHAR_ON_DISPLAY				40

#define NO_POSITION									0xFF
//#define FQ_LASTPOSITION								11		//from 10 20071102
#define FQ_LASTPOSITION								10		//from 10 20071102
#define FQ_LASTDIVISORPOSITION				10

#define DISP_POS_FILTER				CHAR_ON_ONE_LINE+11
#define DISP_POS_PREAMP				CHAR_ON_ONE_LINE+13
#define DISP_POS_MODE					CHAR_ON_ONE_LINE+15
#define DISP_POS_COMPR				CHAR_ON_ONE_LINE+19
#define DISP_POS_FQ						0


extern 	volatile BYTE 				timing1;
extern	volatile char					DisplayBuffer [ CHAR_ON_DISPLAY + 1 ];
extern	volatile char					LastDisplayBuffer [ CHAR_ON_DISPLAY + 1 ];
extern	volatile BYTE					lastDisplayPosition;
extern	volatile BYTE					DisplayCtrlPortValue;
extern	volatile BYTE					EverySecondTime;
extern	volatile BYTE					temp;
extern	volatile BYTE					DisplayTiming;
extern	volatile UINT					TimeBetweenChars;
extern	volatile BYTE					ChangeSizePosition;
extern  volatile BYTE 				NumberOfDigits;
extern  volatile UINT					Displaycount;

void SendToDisplay (  char *	data, 
											BYTE 		position, 
											BYTE 		delay,
											BYTE		count );
void SendCmdToDisplay ( 	BYTE 		data, 
													BYTE 		delay );
BYTE ulong2string ( char * OutString, unsigned int InValue );
BYTE int2stringWsign ( char * OutString, int InValue  );
void Write2display ( void );
void SetCursorPosition ( BYTE Position );
void Make2string ( BYTE * data, BYTE value );
void Make2Hex ( BYTE * data, BYTE value );



#endif

