//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
//
//  This code is distributed under the GNU Public License
//  which can be found at http://www.gnu.org/licenses/gpl.txt

/*----------------------------------------------------------------------------
* File Name           : eepromhandler.h
// Object              : QROlleSAM7S Board Features Definition File.
//
// Creation            : NSn   20080111
*----------------------------------------------------------------------------
*/
#ifndef eepromhandler_h
#define eepromhandler_h

//#define SetEEPROM_WriteActive ((PORTB)&=~(FlashPROMWriteProtect));((PORTB)|=FlashPROMHold);((PORTE)&=~(FlashPROMCS_))
//#define SetEEPROM_ReadActive ((PORTB)|=FlashPROMHold);((PORTE)&=~(FlashPROMCS_))


#define WRITE_ENABLE_COMMAND 					0x06
#define WRITE_DISABLE_COMMAND 				0x04
#define READ_EEPROM_STATUS_COMMAND 		0x05
#define WRITE_EEPROM_STATUS_COMMAND 	0x01
#define READ_EEPROM_COMMAND 					0x03
#define WRITE_EEPROM_COMMAND 					0x02

#define EEPROM_ready 									0x01

//_!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

// Check addresses and sizes very thoroughly in EEPROM!!!!!!!
struct FQvalues // Max 32 bytes
{
	UINT f1Hz;
	UINT f10Hz;
	UINT f100Hz;
	UINT f1kHz;
	UINT f10kHz;
	UINT f100kHz;
	UINT f1MHz;
	UINT f10MHz;
};

#define AddSavedFQvalues	   				 32

//Offset up to here max 63!!!!!!

#define SavedParametersB160					0x40
#define SavedParametersB80					0x80
#define SavedParametersB40					0xC0
#define SavedParametersB30					0x100
#define SavedParametersB20					0x140
#define SavedParametersB17					0x180
#define SavedParametersTrans				0x1C0

//Offset into SavedParameters for each band: max 64 
//Check with Board.h to be equal !!!!!!!!!!!!!!!
#define AddAD9834Afrequency  				0
#define AddAD9834Bfrequency  				4
#define AddAD9834Splitfrequency  		8
#define AddIOport0  								12
#define AddIOport1  								13
#define AddADCchannel  							14
#define AddFQstepLen  							16
#define AddwModesA  								18
#define AddbPowerSetting  					20
#define AddwModesB  								21
#define	AddbTuningSetting							23

//#define SizeOfSavedParameters => USE sizeof ( struct Parameters )!!!!!!


#define AddwSmeterValues								0x200
#define SmeterS2												0x200
#define SmeterS3												0x202
#define SmeterS4												0x204
#define SmeterS5												0x206
#define SmeterS6												0x208
#define SmeterS7												0x20A
#define SmeterS8												0x20C
#define SmeterS9												0x20E
#define SmeterS9p10											0x210
#define SmeterS9p20											0x212
#define SmeterS9p30											0x214
 //#define Next address									0x220


#define LastBand	   										0x300
#define AddPot1Volume  									0x301
#define AddBugSpeed	  									0x302

#define AddAD9834RefFrequency						0x304
#define AddDVMReference					 				0x308
#define NextFreeEEPROMaddress						0x30A
#define AddwCheck4eeprom								0x30C
#define AddSMeterTyp										0x30E
#define AddNext													0x30F
#define AddDisplayMode									0x310
#define AddIambicMode										0x311
#define AddBugConnectionMode						0x312
#define AddwUsedDelay	  								0x313
#define AddbBaudrate	  								0x315
#define AddwButtonSoundLen							0x316
#define AddbSMeterDisplay								0x318

//_!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	
extern BYTE * pEEPROM;

BYTE readFromEEPROM ( WORD address_in_EEPROM, BYTE * address, WORD count );

void  send2EEPROM ( WORD address_in_EEPROM, BYTE * address, WORD count );


#endif

